#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "UnzipTest2", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueUnzipTest2Node : IPluginEvaluate
	{
		#region fields & pins
		[Config("Output Count", DefaultValue = 2, MinValue = 2)]
		protected IDiffSpread<int> FOutputCount;
		
		[Input("Input", DefaultValue = 1.0)]
		public ISpread<double> FInputs;
		


		[Output("Output")]
		public ISpread<double> FOutput;

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			this.FOutput.SliceCount = this.FInputs.Count;
			FOutput.SliceCount = SpreadMax;
			
			for (int i = 0; i < SpreadMax; i++)
				FOutput[i] = FInputs[i] * 2;

			//FLogger.Log(LogType.Debug, "hi tty!");
		}
		        #region Set Outputs
        private void SetOutputs()
        {

            if (this.FOutputCount[0] != FInputs.Count)
            {
                if (this.FOutputCount[0] > FInputs.Count)
                {
                    while (this.FOutputCount[0] > FInputs.Count)
                    {
                        InputAttribute attr = new InputAttribute(this.InputPinName + " " + Convert.ToString(this.FInputs.Count + 1));
                        //attr.IsSingle = true;
                        attr.CheckIfChanged = true;
                        //Create new layer Pin
                        IIOContainer<Pin<DX11Resource<T>>> newlayer = this.FIOFactory.CreateIOContainer<Pin<DX11Resource<T>>>(attr);
                        newlayer.IOObject.SliceCount = 1;
                        this.FInputs.Add(newlayer);
                        newlayer.IOObject[0] = new DX11Resource<T>();
                    }
                }
                else
                {
                    while (this.FOutputCount[0] < FInputs.Count)
                    {
                        this.FInputs[this.FInputs.Count - 1].Dispose();
                        this.FInputs.RemoveAt(this.FInputs.Count - 1);
                    }
                }
            }
        }
        #endregion
	}
}
